<template>
    <div class="app-container">
        <el-form :model="queryParams" ref="queryForm" :inline="true" v-show="showSearch" label-width="68px">
            <el-form-item prop="name">
                <el-input v-model="queryParams.name" placeholder="请输入重洗原因名称" clearable @keyup.enter.native="handleQuery" />
            </el-form-item>
            <el-form-item>
                <el-button type="primary" icon="el-icon-search" @click="handleQuery">搜索</el-button>
                <el-button icon="el-icon-refresh" @click="resetQuery">重置</el-button>
            </el-form-item>
        </el-form>

        <el-row :gutter="10" class="mb8">
            <el-col :span="1.5">
                <el-button type="primary" plain icon="el-icon-plus" @click="handleAdd" v-hasPermi="['cloth:reason:add']">新增</el-button>
            </el-col>

            <right-toolbar :showSearch.sync="showSearch" @queryTable="getList"></right-toolbar>
        </el-row>
        <Page uri="/mapi/cloth/reason/list" :request-params="queryParams" ref="pagination">
            <el-table-column label="ID" align="center" prop="id" width="150" />
            <el-table-column label="重洗原因名称" align="center" prop="name" />
            <el-table-column label="重洗类型" align="center" prop="rewashTypeName" />
            <el-table-column label="备注" align="center" prop="remark" show-overflow-tooltip />
            <el-table-column label="创建人" align="center" prop="createBy" />
            <el-table-column label="创建时间" align="center" prop="createTime" />
            <el-table-column label="修改人" align="center" prop="updateBy" />
            <el-table-column label="修改时间" align="center" prop="createTime" />
            <el-table-column label="操作" align="center" class-name="small-padding fixed-width" fixed="right" width="150">
                <template slot-scope="scope">
                    <el-button type="text" icon="el-icon-edit" @click="handleUpdate(scope.row)" v-hasPermi="['cloth:reason:edit']">修改</el-button>
                    <el-button type="text" icon="el-icon-delete" @click="handleDelete(scope.row)" v-hasPermi="['cloth:reason:remove']">删除</el-button>
                </template>
            </el-table-column>
        </Page>

        <!-- 添加或修改衣服重洗原因对话框 -->
        <el-dialog :title="title" :visible.sync="open" size="40%" append-to-body>
            <el-row :gutter="15">
                <el-form ref="form" :model="form" :rules="rules" label-width="100px">
                    <el-col :span="20">
                        <el-form-item label="重洗原因" prop="name">
                            <el-input v-model="form.name" placeholder="请输入重洗原因名称" maxlength="50" show-word-limit />
                        </el-form-item>
                    </el-col>
                    <el-col :span="20">
                        <el-form-item label="重洗类型" prop="rewashTypeId">
                            <el-select v-model="form.rewashTypeId" placeholder="请选择重洗类型" clearable>
                                <el-option v-for="type in rewashTypeList" :key="type.id" :label="type.name" :value="type.id" />
                            </el-select>
                        </el-form-item>
                    </el-col>
                    <el-col :span="20">
                        <el-form-item label="备注" prop="remark">
                            <el-input v-model="form.remark" placeholder="请输入备注" maxlength="50" show-word-limit />
                        </el-form-item>
                    </el-col>
                </el-form>
            </el-row>

            <div slot="footer" class="dialog-footer">
                <el-button type="primary" @click="submitForm" style="margin-left: 5%">提交</el-button>
                <el-button @click="cancel">取 消</el-button>
            </div>
        </el-dialog>
    </div>
</template>

<script>
import { listReason, getReason, delReason, addReason, updateReason, updateReasonStatus } from '@/api/cloth/rewashReason'
import { listRewashType } from '@/api/cloth/rewashType'

export default {
    name: 'rewashReason',
    data() {
        return {
            // 遮罩层
            loading: true,
            // 选中数组
            ids: [],
            // 非单个禁用
            single: true,
            // 非多个禁用
            multiple: true,
            // 显示搜索条件
            showSearch: true,
            // 总条数
            total: 0,
            // 衣服重洗原因表格数据
            reasonList: [],
            // 弹出层标题
            title: '',
            // 是否显示弹出层
            open: false,
            // 查询参数
            queryParams: {
                name: null
            },
            queryParams1: {
                pageNum: 1,
                pageSize: 999
            },
            // 表单参数
            form: {},
            // 表单校验
            rules: {},
            rewashTypeList: []
        }
    },
    created() {
        this.getList()
        this.getRewashTypeList()
    },
    methods: {
        getRewashTypeList() {
            listRewashType(this.queryParams1).then((response) => {
                this.rewashTypeList = response.rows
            })
        },
        /** 查询衣服重洗原因列表 */
        getList() {
            this.$nextTick(() => {
                this.$refs.pagination.handleSearch(true)
            })
        },
        // 取消按钮
        cancel() {
            this.open = false
            this.reset()
        },
        // 表单重置
        reset() {
            this.form = {
                id: null,
                name: null,
                rewashTypeId: null,
                rewashTypeName: null,
                delFlag: null,
                createById: null,
                createBy: null,
                createTime: null,
                updateById: null,
                updateBy: null,
                updateTime: null,
                remark: null
            }
            this.resetForm('form')
        },
        /** 搜索按钮操作 */
        handleQuery() {
            this.getList()
        },
        /** 重置按钮操作 */
        resetQuery() {
            this.resetForm('queryForm')
            this.handleQuery()
        },
        // 多选框选中数据
        handleSelectionChange(selection) {
            this.ids = selection.map((item) => item.id)
            this.single = selection.length !== 1
            this.multiple = !selection.length
        },
        /** 新增按钮操作 */
        handleAdd() {
            this.reset()
            this.open = true
            this.title = '添加衣服重洗原因'
        },
        /** 修改按钮操作 */
        handleUpdate(row) {
            this.reset()
            const id = row.id || this.ids
            getReason(id).then((response) => {
                this.form = response.data
                this.open = true
                this.title = '修改衣服重洗原因'
            })
        },
        /** 提交按钮 */
        submitForm() {
            this.$refs['form'].validate((valid) => {
                if (valid) {
                    if (this.form.id != null) {
                        updateReason(this.form).then((response) => {
                            this.$modal.msgSuccess('修改成功')
                            this.open = false
                            this.getList()
                        })
                    } else {
                        addReason(this.form).then((response) => {
                            this.$modal.msgSuccess('新增成功')
                            this.open = false
                            this.getList()
                        })
                    }
                }
            })
        },
        /** 删除按钮操作 */
        handleDelete(row) {
            const ids = row.id || this.ids
            this.$modal
                .confirm('是否确认删除衣服重洗原因编号为"' + ids + '"的数据项？')
                .then(function () {
                    return delReason(ids)
                })
                .then(() => {
                    this.getList()
                    this.$modal.msgSuccess('删除成功')
                })
                .catch(() => {})
        },
        /** 导出按钮操作 */
        handleExport() {
            this.download(
                'mapi/cloth/reason/export',
                {
                    ...this.queryParams
                },
                `reason_${new Date().getTime()}.xlsx`
            )
        },
        checkClose(done) {
            this.$confirm('是否关闭表单，关闭后数据将丢失？')
                .then(function () {
                    done()
                })
                .then(() => {})
                .catch(() => {})
        }
    }
}
</script>
